﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;

namespace TronServeur
{
    class Program
    {
        private static Socket listenSocket;

        static void Main(string[] args)
        {
            Tron.Tron myTron;            // Moteur du jeu

            //byte nJoueurs = int.Parse(Console.ReadLine());
<<<<<<< HEAD
            byte nJoueurs = 3;      // Nombre de joueurs
=======
            byte nJoueurs = 2;      // Nombre de joueurs
>>>>>>> 8c77d2872e421b198329f7956d5266ffc00a11fb
            byte frequence = 1;    // Temps du tour de jeu (en dixieme de s)
            byte taille = 60;       // Taille du terrain

            // ************************************* Intitialisation partie
            System.Console.WriteLine("Initialisation");

            // Creation de la socket d'écoute TCP
            listenSocket = new Socket(
                    //domaine (IPv4)
                    AddressFamily.InterNetwork,
                    //type de socket (Stream = connecté)
                    SocketType.Stream,
                    ProtocolType.Tcp);

            // Creation du tableau des sockets connectées
            List<Socket> socketsCo = new List<Socket>();

            // Creation du moteur de jeu
            myTron = new Tron.Tron(nJoueurs, taille);

            // Bind et listen
            // Liaison de la socket au point de communication
            listenSocket.Bind(new IPEndPoint(IPAddress.Any, 11111));

            listenSocket.Listen(nJoueurs);

            
            // Acceptation des clients
            for (int i = 0; i < nJoueurs; i++)
            {
                Console.WriteLine("attente " + i);
                Socket connectedSocket = listenSocket.Accept();
                Console.WriteLine("acceptation joueur " + i);

                socketsCo.Add(connectedSocket);
            }

            // Envoie des paramètres
            for (int i = 0; i < nJoueurs; i++)
            {
                byte[] buffer = new byte[4];

                buffer[0] = taille;
                buffer[1] = nJoueurs;
                //numéro du joueur
                buffer[2] = (byte)i;

                buffer[3] = frequence;

                socketsCo[i].Send(buffer, 0, buffer.Length, SocketFlags.None);
            }


            // ************************************* Routine à chaque tour
            System.Console.WriteLine("Routine");

            // Tant que la partie n'est pas finie
            while (!myTron.IsFinished())
            {
                // Réception de la direction de chaque joueur
                byte[] directions = new byte[nJoueurs];
                for (int i = 0; i < nJoueurs; i++)
                {
                    byte[] direction = new byte[1];
                    try
                    {
                        socketsCo[i].Receive(direction, 0, direction.Length, SocketFlags.None);
                        directions[i] = direction[0];
                    }
                    catch ( SocketException sEx)
                    {
                        // On kick le joueur
                        socketsCo.Remove(socketsCo[i]);
                        socketsCo[i].Close();
                    }
                    
                    
                }
                myTron.setDirections(directions);

                // Calcul collision : myTron.Collision(byte[] <toutes les directions>);
                myTron.Collision(directions);

                // Envoie des directions de tous les joueurs à tous les clients
                for (int i = 0; i < nJoueurs; i++)
                {
                    
                    try
                    {
                        socketsCo[i].Send(directions, 0, directions.Length, SocketFlags.None);
                    }
                    catch (SocketException sEx)
                    {
                        // On kick le joueur
                        socketsCo.Remove(socketsCo[i]);
                        socketsCo[i].Close();
                    }
                }
            }


            // ************************************* Conclusion
            System.Console.WriteLine("Conclusion");

            // Fermeture des sockets connectées
            for (int i = 0; i < nJoueurs; i++)
            {
                socketsCo[i].Close();
            }

            // Fermeture socket d'écoute
            listenSocket.Close();

        }
    }
}
